/* @(#)11	1.28.2.1  com/inc/string.h, libcstr, bos320, 9241320a 10/8/92 20:42:10 */

#ifdef _POWER_PROLOG_
/*
 *   ORIGINS: 27,71
 *
 *
 *   (C) COPYRIGHT International Business Machines Corp. 1985,1992
 *   All Rights Reserved
 *   Licensed Materials - Property of IBM
 *   US Government Users Restricted Rights - Use, duplication or
 *   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#endif /* _POWER_PROLOG_ */

/*
 * (c) Copyright 1990, 1991, 1992 OPEN SOFTWARE FOUNDATION, INC. 
 * ALL RIGHTS RESERVED 
 */
#ifndef _H_STRING
#define _H_STRING
#include <sys/types.h>
#include <standards.h>

/*
 *
 *      The ANSI standard requires that certain values be in string.h.
 *      It also requires that if _ANSI_C_SOURCE is defined then ONLY these
 *      values are present. This header includes all the ANSI required entries.
 *      In addition other entries for the XIX system are included.
 *
 */

#ifdef   _ANSI_C_SOURCE

/*
 *	The following definitions (NULL, size_t) are included in <sys/types.h>.
 *	They are also included here to comply with ANSI standards.
 */

#   ifndef NULL
#	define NULL	((void *)0)
#   endif

#   ifndef _SIZE_T
#	define _SIZE_T
	typedef unsigned long	size_t;
#   endif

#   ifdef	_NONSTD_TYPES
	extern char	*memchr();
	extern char	*memcpy();
	extern char	*memset();
	extern int	strcspn();
	extern int	strlen();
	extern int	strspn();
#   elif	defined	_NO_PROTO
	extern void	*memchr();
	extern void	*memcpy();
	extern void	*memset();
	extern size_t 	strcspn();
	extern size_t	strlen();
	extern size_t	strspn();
#   else	/* _NONSTD_TYPES, _NO_PROTO */
	extern void	*memchr(const void *s, int c, size_t n);
	extern void	*memcpy(void *s1, const void *s2, size_t n);
	extern void	*memset(void *s, int c, size_t n);
	extern size_t 	strcspn(const char *s1, const char *s2);
	extern size_t	strlen(const char *s);
	extern size_t	strspn(const char *s1, const char *s2);
#   endif	/* _NONSTD_TYPES, _NO_PROTO */

#   ifdef   _NO_PROTO
	extern void 	*memmove();
	extern char 	*strcpy();
	extern char 	*strncpy();
	extern char 	*strcat();
	extern char	*strncat();
	extern int 	memcmp();
	extern int	strcmp();
	extern int	strncollen();
	extern int	strncmp();
	extern char	*strchr();
	extern char	*strpbrk();
	extern char	*strrchr();
	extern char	*strstr();
	extern char 	*strtok();
	extern char 	*strerror();
	extern int	strcoll();
	extern size_t strxfrm();
#	ifdef _THREAD_SAFE
	    extern char *strtok_r();
	    extern int	strerror_r();
#	endif /* _THREAD_SAFE */

#   else  /*_NO_PROTO */
	extern void 	*memmove(void *s1, const void *s2, size_t n);
	extern char 	*strcpy(char *s1, const char *s2);
	extern char 	*strncpy(char *s1, const char *s2, size_t n);
	extern char 	*strcat(char *s1, const char *s2);
	extern char	*strncat(char *s1, const char *s2, size_t n);
	extern int 	memcmp(const void *s1, const void *s2,size_t n);
	extern int	strcmp(const char *s1, const char *s2);
	extern int	strncmp(const char *s1,const char *s2,size_t n);
	extern int	strncollen(const char *, const int );
	extern char	*strchr(const char *s, int c);
	extern char	*strpbrk(const char *s1, const char *s2);
	extern char	*strrchr(const char *s, int c);
	extern char	*strstr(const char *s1, const char *s2);
	extern char 	*strtok(char *s1, const char *s2);
	extern char 	*strerror(int errnum);
	extern int	strcoll(const char *s1, const char *s2);
	extern size_t strxfrm(char *s1, const char *s2, size_t n);
#	ifdef _THREAD_SAFE
	    extern char *strtok_r(char *, const char *, char **);
	    extern int	strerror_r(int, char *, int);
#	endif /* _THREAD_SAFE */

#   endif /*_NO_PROTO */
#endif /*_ANSI_C_SOURCE */

#ifdef	_XOPEN_SOURCE
#   ifdef	_NONSTD_TYPES
	extern char	*memccpy();
#   elif	defined	_NO_PROTO
	extern void	*memccpy();
#   else	/* _NONSTD_TYPES, _NO_PROTO */
	extern void	*memccpy(void *target, const void *source, int c, size_t n);
#   endif	/* _NONSTD_TYPES, _NO_PROTO */

#   ifdef _NO_PROTO
	extern wchar_t	*wcscat();
	extern wchar_t	*wcschr();
	extern int	wcscmp();
	extern wchar_t	*wcscpy();
	extern size_t	wcscspn();
	extern size_t	wcslen();
	extern wchar_t	*wcsncat();
	extern int	wcsncmp();
	extern wchar_t	*wcsncpy();
	extern wchar_t	*wcspbrk();
	extern wchar_t	*wcsrchr();
	extern size_t	wcsspn();
	extern wchar_t	*wcstok();
	extern wchar_t	*wcswcs();
	extern int	wcswidth();
	extern int	wcwidth();
	extern int	wcscoll();
	extern size_t wcsxfrm();
#ifdef _THREAD_SAFE
	extern wchar_t	*wcstok_r();
	extern int 	dirname_r();
#endif   /* _THREAD_SAFE */
#   else /* _NO_PROTO */
	extern wchar_t	*wcscat(wchar_t *ws1, const wchar_t *ws2);
	extern wchar_t	*wcschr(const wchar_t *ws, wchar_t wc);
	extern int	wcscmp(const wchar_t *ws1, const wchar_t *ws2);
	extern wchar_t	*wcscpy(wchar_t *ws1, const wchar_t *ws2);
	extern size_t	wcscspn(const wchar_t *wc1, const wchar_t *ws2);
	extern size_t	wcslen(const wchar_t *ws);
	extern wchar_t	*wcsncat(wchar_t *ws1, const wchar_t *ws2, size_t n);
	extern int	wcsncmp(const wchar_t *ws1, const wchar_t *ws2, size_t n);
	extern wchar_t	*wcsncpy(wchar_t *ws1, const wchar_t *ws2, size_t n);
	extern wchar_t	*wcspbrk(const wchar_t *ws1, const wchar_t *ws2);
	extern wchar_t	*wcsrchr(const wchar_t *ws1, wchar_t wc);
	extern size_t	wcsspn(const wchar_t *ws1, const wchar_t *ws2);
	extern wchar_t	*wcstok(wchar_t *ws1, const wchar_t *ws2);
	extern wchar_t	*wcswcs(const wchar_t *ws1, const wchar_t *ws2);
	extern int	wcswidth(const wchar_t *ws1, size_t n);
	extern int	wcwidth(const wchar_t wc);
	extern int	wcscoll(const wchar_t *wcs1, const wchar_t *wcs2);
	extern size_t wcsxfrm(wchar_t *s1, const wchar_t *s2, size_t n);
#ifdef _THREAD_SAFE
	extern wchar_t  *wcstok_r(wchar_t *ws1, const wchar_t *ws2, wchar_t **savept);
	extern int 	dirname_r(char *path, char *buf, int size);
#endif   /* _THREAD_SAFE */
#   endif /* _NO_PROTO */
#endif	/* _XOPEN_SOURCE */

#ifdef	_ALL_SOURCE
#   ifdef	_NO_PROTO
	extern char     *rindex();
	extern char	*strdup();
	extern void	swab();
#   else	/*_NO_PROTO */
	extern char     *rindex(const char *s, int c);
	extern char	*strdup(char *s);
	extern void	swab(short *, short *, int);
#   endif	/* _NO_PROTO */
#endif	/* _ALL_SOURCE */

/*
 *   The following macro definitions cause the XLC compiler to inline
 *   these functions whenever possible.
 */
 
#ifdef __STR__
#   define strcpy(s1,s2) __strcpy(s1,s2)
#   define strcmp(s1,s2) __strcmp(s1,s2)

#   ifndef __STR31__
#	define strlen(s1) __strlen(s1)
#	define strchr(s1,c) __strchr(s1,c)
#	define strrchr(s1,c) __strrchr(s1,c)
#	define strcat(s1,s2) __strcat(s1,s2)
#	define index(s1,c) __strchr(s1,c)
#	define rindex(s1,c) __strrchr(s1,c)
#	define memchr(s1,c,n) __memchr(s1,c,n)
#	define memcpy(s1,s2,n) __memcpy(s1,s2,n)
#	define memmove(s1,s2,n) __memmove(s1,s2,n)
#	define memcmp(s1,s2,n) __memcmp(s1,s2,n)
#	define memset(s1,c,n) __memset(s1,c,n)
/*
 *   __XLC121__	is automatically defined by the	XLC 1.2.1 compiler so that
 *   the compiler can inline the following functions when possible.
 */
#     ifdef __XLC121__
#	define memccpy(target,source,c,n)  __memccpy(target,source,c,n)
#	define strncat(s1, s2, n)    __strncat(s1, s2, n)
#	define strncmp(s1, s2, n)    __strncmp(s1, s2, n)
#	define strncpy(s1, s2, n)    __strncpy(s1, s2, n)
#     endif /*__XLC121__ */
#   endif /* ifndef __STR31__ */
#endif /* __STR__ */

 
#endif /* _H_STRING */
